
// IDs
const JSLIB_RDF_PROGID = '@mozilla.org/rdf/rdf-service;1';
const JSLIB_CONTAINER_PROGID = '@mozilla.org/rdf/container;1';
const JS_DIR_UTILS_FILE_DIR_CID = "@mozilla.org/file/directory_service;1";

// get RDF service interface
var RDF = Components.classes[JSLIB_RDF_PROGID].getService();
RDF = this.RDF.QueryInterface(Components.interfaces.nsIRDFService);

// get RDF container service interface
var RDFC = Components.classes[JSLIB_CONTAINER_PROGID].getService();
RDFC = this.RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

// get directotry constructor
var DIR = new Components.Constructor(JS_DIR_UTILS_FILE_DIR_CID,"nsIProperties");

// the data source
var ds = null;

function getDataSrc(src) {
  try { 
    dir = new DIR()
    src = "file://" + dir.get("AChrom", Components.interfaces.nsIFile).path + "\\bug87499\\content\\" + src;
  }
  catch (e) {
    alert("chrome dir failed: "+src);
  }

  // get RDF data source for src
  try {
    ds = RDF.GetDataSource(src);
  }
  catch (e) { alert("getting failed: "+src) }
}

function flushDataSrc() {
  // get Remote RDF servive interface
  var remote = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);

  // get RDF data source for src
  try {
    remote.Flush();
  }
  catch (e) { alert("flushing failed") }
}

function addNode(node) {
  var res = RDF.GetResource("urn:root:"+node);

  alert("adding urn:root:"+node)

  var parentres = RDF.GetResource("urn:root");
  if( parentres) {
     RDFC.Init(ds, parentres);

     RDFC.AppendElement(res);
  }
}

